DjangoBook/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include("page.urls")),
    path('blog/', include("blog.urls")),
    path('book/', include("blog.urls")),
    path('posts/', include("posts.urls")),
    path('blogapp/', include("blogapp.urls")),
    path('accounts/', include('accounts.urls')),
    path('accounts/', include("django.contrib.auth.urls")),
]+ static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

accounts/urls.py
from django.urls import path

from .views import SignUpView

urlpatterns =[
    path('signup/', SignUpView.as_view(), name='signup')
]

blog/urls.py
from django.urls import path
from . import views

urlpatterns = [
    # path('', views.SignUpView.as_view(), name='signup'),

]

blogapp/urls.py
from django.urls import path, include
from . import views
urlpatterns = [
    path('', views.BlogListView.as_view(), name='bloghome'),
    path('post/<int:pk>/', views.BlogDetailView.as_view(), name='blog-details-home'),
    path('post/new/', views.BlogCreateView.as_view(), name='blog_create_home'),
    path('post/<int:pk>/edit/', views.BlogUpdateView.as_view(), name='post_edit'),
    path('post/<int:pk>/delete/', views.BlogDeleteView.as_view(), name='post_delete'),
]

book/urls.py
from django.urls import path
from . import views
urlpatterns = [
    path('', views.SignUpView.as_view(), name='signup'),
]

page/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('', views.SignUpView.as_view(), name='signup'),
    path('validate_username/', views.validate_username, name='validate_username'),
]

posts/urls.py
from django.urls import path
from .views import HomePageView
urlpatterns = [
    path('', HomePageView.as_view(), name="homepage")
]

accounts/models.py
from django.db import models

# Create your models here.

blog/models.py
from django.db import models

# Create your models here.

blogapp/models.py
from django.db import models
from django.urls import reverse

# Create your models here.


class Post(models.Model):
    title = models.CharField(max_length=200)
    author = models.ForeignKey('auth.User',on_delete=models.CASCADE)
    body = models.TextField()

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse('blog-details-home',args=[str(self.id)])

book/models.py
from django.db import models

# Create your models here.
class Book(models.Model):
    HARDCOVER =1
    PAPERBACK =2
    EBOOK =3
    BOOK_TYPES =(
        (HARDCOVER, 'hardcover'),
        (PAPERBACK, 'Paperback'),
        (EBOOK,'E-book')
    )

    title = models.CharField(max_length=50)
    publication_date = models.DateTimeField(null=True)
    author = models.CharField(max_length=30, blank=True)
    price = models.DecimalField(max_digits=5, decimal_places=2)
    pages = models.IntegerField(blank=True, null=True)
    book_type = models.PositiveSmallIntegerField(choices=BOOK_TYPES)

page/models.py
from django.db import models

# Create your models here.

posts/models.py
from django.db import models

# Create your models here.


class Post(models.Model):
    text = models.TextField()

    def __str__(self):
        return self.text[:20]

book/forms.py
from django import forms
from .models import Book

class BookForm(forms.ModelForm):
    class Meta:
        model=Book
        fields = ('title','publication_date','author', 'price', 'pages','book_type')

accounts/views.py
from django.contrib.auth.forms import UserCreationForm
from django.urls import reverse_lazy
from django.views import generic


# Create your views here.


class SignUpView(generic.CreateView):
    form_class = UserCreationForm
    success_url = reverse_lazy('login')
    template_name = 'signup.html'

blog/views.py
from django.shortcuts import render

# Create your views here.

blogapp/views.py
from django.views.generic import ListView, DeleteView
from django.views.generic.edit import CreateView, UpdateView, DeleteView
from django.urls import reverse_lazy

from .models import Post

class BlogListView(ListView):
    model = Post
    template_name = 'blog_home.html'
    context_object_name = 'all_post'


class BlogDetailView(DeleteView):
    model = Post
    template_name = 'post_detail.html'


class BlogCreateView(CreateView):
    model = Post
    template_name = 'post_new.html'
    fields = '__all__'


class BlogUpdateView(UpdateView):
    model = Post
    template_name = 'post_edit.html'
    fields = ['title', 'body']


class BlogDeleteView(DeleteView):
    model = Post
    template_name = 'post_delete.html'
    success_url = reverse_lazy('bloghome')

book/views.py
from django.http import JsonResponse
from django.shortcuts import render
from django.template.loader import render_to_string
from .models import Book
from .forms import BookForm

def book_list(request):
    books = Book.objects.all()
    return render(request, 'book_list.html',{'books:books'})

def boo_create(request):
    form =BookForm()
    context = {'form': form}
    html_form = render_to_string('',
                                 context,
                                 request=request)
    return JsonResponse({'html_form': html_form})

page/views.py
from django.contrib.auth.forms import UserCreationForm
from django.views.generic.edit import CreateView
from django.contrib.auth.models import User
from django.http import JsonResponse


class SignUpView(CreateView):
    template_name = 'index.html'
    form_class = UserCreationForm


def validate_username(request):
    username = request.GET.get('username', None)
    data = {
        'is_taken': User.objects.filter(username__iexact=username).exists()
    }
    return JsonResponse(data)

posts/views.py
from django.views.generic import ListView
from .models import Post


class HomePageView(ListView):
    model = Post
    template_name = 'posts_index.html'
    context_object_name = 'all_object'

blogapp/templates/blog_home.html
{% extends 'base.html' %}
{% block content %}

    {% for post in all_post %}
  <div class="post-entry">
  <h2><a href="{% url 'blog-details-home' post.pk %}">{{ post.title }}</a></h2>
  <p>{{ post.body }}</p>

  </div>
    {% endfor %}

{% endblock %}

blogapp/templates/post_delete.html
{% extends 'base.html' %}
{% block content %}
    <h1>Delete Post</h1>
    <form action="" method="post">
    {% csrf_token %}
    <p>Are you sure you want to delete{{ post.title }}?</p>
    <input type="submit" value="Confirm"/>
    </form>
{% endblock %}

blogapp/templates/post_detail.html
{% extends 'base.html' %}
{% block content %}
<div class="post_entry">
<h2>{{ post.title }}</h2>
<p>{{ post.body }}</p>
</div>
    <a href="{% url 'post_edit' post.pk %}">+ Edit Blog Post</a>
    <p><a href="{% url 'post_delete' post.pk %}">+Delete Blog Post</a></p>
{% endblock %}

blogapp/templates/post_edit.html
{% extends 'base.html' %}
{% block content %}
    <h1>Edit Post</h1>
    <form action="" method="POST">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Update</button>

    </form>
{% endblock %}

blogapp/templates/post_new.html
{% extends 'base.html' %}
{% block content %}
  <h1>New post</h1>
    <form action="" method="POST">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Save</button>
    </form>
{% endblock %}

posts/templates/posts_index.html
{% extends 'base.html' %}
{% block content %}
<h1>Message board homepage</h1>
    <ul>
      {% for post in all_object %}
          <li>{{ post }}</li>
    {% endfor %}

    </ul>
{% endblock %}

templates/base.html
{% load static %}
<!doctype html>
<html>
<head>
    <meta charset="utf-8">
    <title>{% block title %}Default Title{% endblock %}</title>
    <link href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:􀇓􀇏􀇏"
          rel="stylesheet">
    <link rel="stylesheet" type="text/css" href="{% static 'css/app.css' %}">
    {#    {% block stylesheet %}#}
    {##}
    {#    {% endblock %}#}
</head>
<body>
<header>
    <div class="nav-left">
        <h1><a href="{% url 'bloghome' %}">Django blog</a></h1>
    </div>
    <div class="nav-right">
        <a href="{% url 'blog_create_home' %}">+ New Blog Post</a>
    </div>
</header>
{% if user.is_authenticated %}
    <p>hi {{ user.username }}</p>
    <p><a href="{% url 'logout' %}">Log Out</a></p>
    {% else %}
    <p>You are not logged in.</p>
    <a href="{% url 'login' %}">Log In</a>
{% endif %}



{% block content %}
{% endblock %}

<script src="https://code.jquery.com/jquery-3.1.0.min.js"></script>
<script src="{% static 'js/app.js' %}"></script>
{% block javascript %}{% endblock %}
</body>
</html>

templates/blog_index.html
{% extends 'base.html' %}
{% block content %}

{% endblock %}

templates/book_list.html
{% extends 'base.html' %}
{% include 'header.html' %}
{% block content %}

    <h1 class="page-header">Books</h1>
    <!-- Button to tigger the action-->
    <p>
        <button type="button" class="btn btn-primary js-create-book">
            <span class="glypicon glyphicon-plus"></span>New Book
        </button>
    </p>

{#table for content#}
    <table class="table" id="book-table">
      <thead>
      <tr>
        <th>#</th>
        <th>Title</th>
        <th>Author</th>
        <th>Type</th>
        <th>Publication date</th>
        <th>Pages</th>
        <th>Price</th>


      </tr>
      </thead>
    <tbody>
     {% for book in book_list %}
         <tr>
         <td>{{ book.id }}</td>
         <td>{{ book.title }}</td>
         <td>{{ book.author }}</td>
         <td>{{ book.get_book_type_display }}</td>
         <td>{{ book.publication_date }}</td>
         <td>{{ book.pages }}</td>
         <td>{{ book.price }}</td>
         </tr>
         {% empty %}
         <tr>
           <td colspan="7" class="text-center bg-warning">No Book</td>
         </tr>
    {% endfor %}
    </tbody>
    </table>
{#    the modal we will be using #}
    <div class="modal fade" id="modal-book">

    </div>
{% endblock %}

templates/header.html
{% extends 'base.html' %}
{% block stylesheet %}
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
{% endblock %}
{% block content %}
         <nav class="navbar navbar-light bg-light justify-content-between">
        <a class="navbar-brand">Pythonreal.co</a>
        <form class="form-inline">
         <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search">
         <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
        </form>
        </nav>
{% endblock %}

templates/index.html
{% extends 'base.html' %}
{% block javascript %}
 <script>
    $("#id_username").change(function () {
      var username = $(this).val();

      $.ajax({
        url: 'validate_username/',
        data: {
          'username': username
        },
        dataType: 'json',
        success: function (data) {
          if (data.is_taken) {
            document.write("A user with this username already exists.");
          }
        }
      });

    });
  </script>
{% endblock %}
{% block content %}
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Sign up</button>
  </form>
{% endblock %}

templates/partial_book_create.html
{% load widget_tweaks %}

<form method="post">
    {% csrf_token %}


</form>

templates/signup.html
{% extends 'base.html' %}
{% block content %}
    <h2>Sign up</h2>
    <form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Sign Up</button>

    </form>
{% endblock %}